package sample.cmd;

import java.util.Arrays;

import javax.ejb.EJB;

import sample.GlobalAccount;
import sample.GlobalAccountManager;
import sample.Role;
import sample.RoleManager;

public class Main {

    enum Command {
        CREATE_USER, DELETE_USER, GET_USER, CREATE_ROLE, DELETE_ROLE, GET_ROLE
    }

    @EJB
    static GlobalAccountManager gaManager;

    @EJB
    static RoleManager roleManager;

    public static void main(String... args) {
        switch (Command.valueOf(args[0].toUpperCase().replaceAll("-", "_"))) {
        case CREATE_USER:
            GlobalAccount ga = new GlobalAccount();
            ga.setAccountId(args[1]);
            ga = gaManager.create(ga, Arrays.copyOfRange(args, 2, args.length));
            System.err.printf("User created: %s%n", ga);
            break;
        case DELETE_USER:
            ga = gaManager.delete(args[1]);
            System.err.printf("User deleted: %s%n", ga);
            break;
        case GET_USER:
            ga = gaManager.get(args[1]);
            System.err.printf("User: %s%n", ga);
            break;
        case CREATE_ROLE:
            Role role = new Role();
            role.setName(args[1]);
            role = roleManager.create(role);
            System.err.printf("Role created: %s%n", role);
            break;
        case DELETE_ROLE:
            role = roleManager.delete(args[1]);
            System.err.printf("Role deleted: %s%n", role);
            break;
        case GET_ROLE:
            role = roleManager.get(args[1]);
            System.err.printf("Role: %s%n", role);
            break;
        default:
            throw new AssertionError();
        }
    }
}
