package sample;

import java.util.ArrayList;
import java.util.List;

import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

@Stateless
public class GlobalAccountManagerBean implements GlobalAccountManager {

    @PersistenceContext
    protected EntityManager entityManager;

    @EJB
    private RoleManager roleManager;

    public GlobalAccount create(GlobalAccount ga, String... roleNames) {
        entityManager.persist(ga);

        List<Role> roles = new ArrayList<Role>(roleNames.length);
        for (String roleName : roleNames) {
            roles.add(roleManager.get(roleName));
        }
        ga.setRoles(roles);

        entityManager.flush();

        ga.setComment("test");
        return ga;
    }

    public GlobalAccount delete(String accountId) {
        GlobalAccount ga = get(accountId);
        entityManager.remove(ga);
        entityManager.flush();
        return ga;
    }

    public GlobalAccount get(String accountId) {
        GlobalAccount ga = (GlobalAccount) entityManager.createQuery(
                "SELECT e FROM GlobalAccount e WHERE e.accountId = :value").setParameter("value", accountId)
                .getSingleResult();
        return ga;
    }
}
